org.apache.xpath.objects

## Class XStringForFSB

- java.lang.Object
- - org.apache.xpath.Expression
  - - org.apache.xpath.objects.XObject
    - - org.apache.xpath.objects.XString
      - - org.apache.xpath.objects.XStringForFSB

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, javax.xml.transform.SourceLocator, XMLString, ExpressionNode, XPathVisitable

      public class XStringForFSB
      extends XString

  This class will wrap a FastStringBuffer and allow for
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.xpath.objects.XString

      `EMPTYSTRING`

    - ### Fields inherited from class org.apache.xpath.objects.XObject

      `CLASS_BOOLEAN, CLASS_NODESET, CLASS_NULL, CLASS_NUMBER, CLASS_RTREEFRAG, CLASS_STRING, CLASS_UNKNOWN, CLASS_UNRESOLVEDVARIABLE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `XStringForFSB(FastStringBuffer val, int start, int length)` Construct a XNodeSet object.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `appendToFsb(FastStringBuffer fsb)` Cast result object to a string.
    `char` | `charAt(int index)` Returns the character at the specified index.
    `int` | `compareTo(XMLString xstr)` Compares two strings lexicographically.
    `int` | `compareToIgnoreCase(XMLString xstr)` Compares two strings lexicographically, ignoring case considerations.
    `XMLString` | `concat(java.lang.String str)` Concatenates the specified string to the end of this string.
    `void` | `dispatchAsComment(org.xml.sax.ext.LexicalHandler lh)` Directly call the comment method on the passed LexicalHandler for the string-value.
    `void` | `dispatchCharactersEvents(org.xml.sax.ContentHandler ch)` Directly call the characters method on the passed ContentHandler for the string-value.
    `boolean` | `equals(java.lang.Object obj2)` Compares this string to the specified object.
    `boolean` | `equals(java.lang.String anotherString)` Tell if two objects are functionally equal.
    `boolean` | `equals(XMLString obj2)` Compares this string to the specified object.
    `boolean` | `equals(XObject obj2)` Tell if two objects are functionally equal.
    `boolean` | `equalsIgnoreCase(java.lang.String anotherString)` Compares this `String` to another `String`, ignoring case considerations.
    `XMLString` | `fixWhiteSpace(boolean trimHead, boolean trimTail, boolean doublePunctuationSpaces)` Conditionally trim all leading and trailing whitespace in the specified String.
    `FastStringBuffer` | `fsb()` Cast result object to a string.
    `void` | `getChars(int srcBegin, int srcEnd, char[] dst, int dstBegin)` Copies characters from this string into the destination character array.
    `int` | `hashCode()` Returns a hashcode for this string.
    `boolean` | `hasString()` Tell if this object contains a java String object.
    `int` | `indexOf(int ch)` Returns the index within this string of the first occurrence of the specified character.
    `int` | `indexOf(int ch, int fromIndex)` Returns the index within this string of the first occurrence of the specified character, starting the search at the specified index.
    `int` | `length()` Returns the length of this string.
    `java.lang.Object` | `object()` Since this object is incomplete without the length and the offset, we have to convert to a string when this function is called.
    `boolean` | `startsWith(XMLString prefix)` Tests if this string starts with the specified prefix.
    `boolean` | `startsWith(XMLString prefix, int toffset)` Tests if this string starts with the specified prefix beginning a specified index.
    `java.lang.String` | `str()` Cast result object to a string.
    `XMLString` | `substring(int beginIndex)` Returns a new string that is a substring of this string.
    `XMLString` | `substring(int beginIndex, int endIndex)` Returns a new string that is a substring of this string.
    `double` | `toDouble()` Convert a string to a double -- Allowed input is in fixed notation ddd.fff.
    `XMLString` | `trim()` Removes white space from both ends of this string.

    - ### Methods inherited from class org.apache.xpath.objects.XString

      `bool, callVisitors, endsWith, getType, getTypeString, indexOf, indexOf, indexOf, lastIndexOf, lastIndexOf, lastIndexOf, lastIndexOf, num, rtf, startsWith, startsWith, toLowerCase, toLowerCase, toUpperCase, toUpperCase, xstr`

    - ### Methods inherited from class org.apache.xpath.objects.XObject

      `allowDetachToRelease, boolWithSideEffects, castToType, create, create, deepEquals, destruct, detach, execute, fixupVariables, getFresh, greaterThan, greaterThanOrEqual, iter, lessThan, lessThanOrEqual, mutableNodeset, nodelist, nodeset, notEquals, numWithSideEffects, reset, rtf, rtree, rtree, toString`

    - ### Methods inherited from class org.apache.xpath.Expression

      `asIterator, asIteratorRaw, asNode, assertion, bool, canTraverseOutsideSubtree, error, execute, execute, execute, executeCharsToContentHandler, exprAddChild, exprGetChild, exprGetNumChildren, exprGetParent, exprSetParent, getColumnNumber, getExpressionOwner, getLineNumber, getPublicId, getSystemId, isNodesetExpr, isStableNumber, num, warn, xstr`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.xml.utils.XMLString

      `toString`

- - ### Constructor Detail

    - #### XStringForFSB

          public XStringForFSB(FastStringBuffer val,
                               int start,
                               int length)

      Construct a XNodeSet object.
      Parameters:
        `val` - FastStringBuffer object this will wrap, must be non-null.
        `start` - The start position in the array.
        `length` - The number of characters to read from the array.

  - ### Method Detail

    - #### fsb

          public FastStringBuffer fsb()

      Cast result object to a string.
      Returns:
        The string this wraps or the empty string if null

    - #### appendToFsb

          public void appendToFsb(FastStringBuffer fsb)

      Cast result object to a string.
      Overrides:
        `appendToFsb` in class `XObject`

    - #### hasString

          public boolean hasString()

      Tell if this object contains a java String object.
      Specified by:
        `hasString` in interface `XMLString`
      Overrides:
        `hasString` in class `XString`
      Returns:
        true if this XMLString can return a string without creating one.

    - #### object

          public java.lang.Object object()

      Since this object is incomplete without the length and the offset, we have to convert to a string when this function is called.
      Overrides:
        `object` in class `XObject`
      Returns:
        The java String representation of this object.

    - #### str

          public java.lang.String str()

      Cast result object to a string.
      Overrides:
        `str` in class `XString`
      Returns:
        The string this wraps or the empty string if null

    - #### dispatchCharactersEvents

          public void dispatchCharactersEvents(org.xml.sax.ContentHandler ch)
                                        throws org.xml.sax.SAXException

      Directly call the characters method on the passed ContentHandler for the string-value. Multiple calls to the ContentHandler's characters methods may well occur for a single call to this method.
      Specified by:
        `dispatchCharactersEvents` in interface `XMLString`
      Overrides:
        `dispatchCharactersEvents` in class `XString`
      Parameters:
        `ch` - A non-null reference to a ContentHandler.
      Throws:
        `org.xml.sax.SAXException`

    - #### dispatchAsComment

          public void dispatchAsComment(org.xml.sax.ext.LexicalHandler lh)
                                 throws org.xml.sax.SAXException

      Directly call the comment method on the passed LexicalHandler for the string-value.
      Specified by:
        `dispatchAsComment` in interface `XMLString`
      Overrides:
        `dispatchAsComment` in class `XString`
      Parameters:
        `lh` - A non-null reference to a LexicalHandler.
      Throws:
        `org.xml.sax.SAXException`

    - #### length

          public int length()

      Returns the length of this string.
      Specified by:
        `length` in interface `XMLString`
      Overrides:
        `length` in class `XString`
      Returns:
        the length of the sequence of characters represented by this object.

    - #### charAt

          public char charAt(int index)

      Returns the character at the specified index. An index ranges from `0` to `length() - 1`. The first character of the sequence is at index `0`, the next at index `1`, and so on, as for array indexing.
      Specified by:
        `charAt` in interface `XMLString`
      Overrides:
        `charAt` in class `XString`
      Parameters:
        `index` - the index of the character.
      Returns:
        the character at the specified index of this string. The first character is at index `0`.
      Throws:
        `java.lang.IndexOutOfBoundsException` - if the `index` argument is negative or not less than the length of this string.

    - #### getChars

          public void getChars(int srcBegin,
                               int srcEnd,
                               char[] dst,
                               int dstBegin)

      Copies characters from this string into the destination character array.
      Specified by:
        `getChars` in interface `XMLString`
      Overrides:
        `getChars` in class `XString`
      Parameters:
        `srcBegin` - index of the first character in the string to copy.
        `srcEnd` - index after the last character in the string to copy.
        `dst` - the destination array.
        `dstBegin` - the start offset in the destination array.
      Throws:
        `java.lang.IndexOutOfBoundsException` - If any of the following is true:
        - `srcBegin` is negative.
        - `srcBegin` is greater than `srcEnd`
        - `srcEnd` is greater than the length of this string
        - `dstBegin` is negative
        - `dstBegin+(srcEnd-srcBegin)` is larger than `dst.length`
        `java.lang.NullPointerException` - if `dst` is `null`

    - #### equals

          public boolean equals(XMLString obj2)

      Compares this string to the specified object. The result is `true` if and only if the argument is not `null` and is a `String` object that represents the same sequence of characters as this object.
      Specified by:
        `equals` in interface `XMLString`
      Overrides:
        `equals` in class `XString`
      Parameters:
        `obj2` - the object to compare this `String` against.
      Returns:
        `true` if the `String` are equal; `false` otherwise.
      See Also:
        `String.compareTo(java.lang.String)`, `String.equalsIgnoreCase(java.lang.String)`

    - #### equals

          public boolean equals(XObject obj2)

      Tell if two objects are functionally equal.
      Overrides:
        `equals` in class `XString`
      Parameters:
        `obj2` - Object to compare this to
      Returns:
        true if the two objects are equal
      Throws:
        `javax.xml.transform.TransformerException`

    - #### equals

          public boolean equals(java.lang.String anotherString)

      Tell if two objects are functionally equal.
      Specified by:
        `equals` in interface `XMLString`
      Overrides:
        `equals` in class `XString`
      Parameters:
        `anotherString` - Object to compare this to
      Returns:
        true if the two objects are equal
      Throws:
        `javax.xml.transform.TransformerException`
      See Also:
        `String.compareTo(java.lang.String)`, `String.equalsIgnoreCase(java.lang.String)`

    - #### equals

          public boolean equals(java.lang.Object obj2)

      Compares this string to the specified object. The result is `true` if and only if the argument is not `null` and is a `String` object that represents the same sequence of characters as this object.
      Specified by:
        `equals` in interface `XMLString`
      Overrides:
        `equals` in class `XString`
      Parameters:
        `obj2` - the object to compare this `String` against.
      Returns:
        `true` if the `String` are equal; `false` otherwise.
      See Also:
        `String.compareTo(java.lang.String)`, `String.equalsIgnoreCase(java.lang.String)`

    - #### equalsIgnoreCase

          public boolean equalsIgnoreCase(java.lang.String anotherString)

      Compares this `String` to another `String`, ignoring case considerations. Two strings are considered equal ignoring case if they are of the same length, and corresponding characters in the two strings are equal ignoring case.
      Specified by:
        `equalsIgnoreCase` in interface `XMLString`
      Overrides:
        `equalsIgnoreCase` in class `XString`
      Parameters:
        `anotherString` - the `String` to compare this `String` against.
      Returns:
        `true` if the argument is not `null` and the `String`s are equal, ignoring case; `false` otherwise.
      See Also:
        `equals(Object)`, `Character.toLowerCase(char)`, `Character.toUpperCase(char)`

    - #### compareTo

          public int compareTo(XMLString xstr)

      Compares two strings lexicographically.
      Specified by:
        `compareTo` in interface `XMLString`
      Overrides:
        `compareTo` in class `XString`
      Parameters:
        `xstr` - the `String` to be compared.
      Returns:
        the value `0` if the argument string is equal to this string; a value less than `0` if this string is lexicographically less than the string argument; and a value greater than `0` if this string is lexicographically greater than the string argument.
      Throws:
        `java.lang.NullPointerException` - if `anotherString` is `null`.

    - #### compareToIgnoreCase

          public int compareToIgnoreCase(XMLString xstr)

      Compares two strings lexicographically, ignoring case considerations. This method returns an integer whose sign is that of `this.toUpperCase().toLowerCase().compareTo( str.toUpperCase().toLowerCase())`.

      Note that this method does not take locale into account, and will result in an unsatisfactory ordering for certain locales. The java.text package provides collators to allow locale-sensitive ordering.

      Specified by:
        `compareToIgnoreCase` in interface `XMLString`
      Overrides:
        `compareToIgnoreCase` in class `XString`
      Parameters:
        `xstr` - the `String` to be compared.
      Returns:
        a negative integer, zero, or a positive integer as the the specified String is greater than, equal to, or less than this String, ignoring case considerations.
      Since:
        1.2
      See Also:
        `Collator.compare(String, String)`

    - #### hashCode

          public int hashCode()

      Returns a hashcode for this string. The hashcode for a `String` object is computed as

      >      s[0]*31^(n-1) + s[1]*31^(n-2) + ... + s[n-1]

      using `int` arithmetic, where `s[i]` is the ith character of the string, `n` is the length of the string, and `^` indicates exponentiation. (The hash value of the empty string is zero.)
      Specified by:
        `hashCode` in interface `XMLString`
      Overrides:
        `hashCode` in class `XString`
      Returns:
        a hash code value for this object.

    - #### startsWith

          public boolean startsWith(XMLString prefix,
                                    int toffset)

      Tests if this string starts with the specified prefix beginning a specified index.
      Specified by:
        `startsWith` in interface `XMLString`
      Overrides:
        `startsWith` in class `XString`
      Parameters:
        `prefix` - the prefix.
        `toffset` - where to begin looking in the string.
      Returns:
        `true` if the character sequence represented by the argument is a prefix of the substring of this object starting at index `toffset`; `false` otherwise. The result is `false` if `toffset` is negative or greater than the length of this `String` object; otherwise the result is the same as the result of the expression

                      this.subString(toffset).startsWith(prefix)

      Throws:
        `java.lang.NullPointerException` - if `prefix` is `null`.

    - #### startsWith

          public boolean startsWith(XMLString prefix)

      Tests if this string starts with the specified prefix.
      Specified by:
        `startsWith` in interface `XMLString`
      Overrides:
        `startsWith` in class `XString`
      Parameters:
        `prefix` - the prefix.
      Returns:
        `true` if the character sequence represented by the argument is a prefix of the character sequence represented by this string; `false` otherwise. Note also that `true` will be returned if the argument is an empty string or is equal to this `String` object as determined by the `equals(Object)` method.
      Throws:
        `java.lang.NullPointerException` - if `prefix` is `null`.
      Since:
        JDK1. 0

    - #### indexOf

          public int indexOf(int ch)

      Returns the index within this string of the first occurrence of the specified character. If a character with value `ch` occurs in the character sequence represented by this `String` object, then the index of the first such occurrence is returned -- that is, the smallest value k such that:

      >      this.charAt(k) == ch

      is `true`. If no such character occurs in this string, then `-1` is returned.
      Specified by:
        `indexOf` in interface `XMLString`
      Overrides:
        `indexOf` in class `XString`
      Parameters:
        `ch` - a character.
      Returns:
        the index of the first occurrence of the character in the character sequence represented by this object, or `-1` if the character does not occur.

    - #### indexOf

          public int indexOf(int ch,
                             int fromIndex)

      Returns the index within this string of the first occurrence of the specified character, starting the search at the specified index.

      If a character with value `ch` occurs in the character sequence represented by this `String` object at an index no smaller than `fromIndex`, then the index of the first such occurrence is returned--that is, the smallest value k such that:

      >      (this.charAt(k) == ch) && (k >= fromIndex)

      is true. If no such character occurs in this string at or after position `fromIndex`, then `-1` is returned.

      There is no restriction on the value of `fromIndex`. If it is negative, it has the same effect as if it were zero: this entire string may be searched. If it is greater than the length of this string, it has the same effect as if it were equal to the length of this string: `-1` is returned.

      Specified by:
        `indexOf` in interface `XMLString`
      Overrides:
        `indexOf` in class `XString`
      Parameters:
        `ch` - a character.
        `fromIndex` - the index to start the search from.
      Returns:
        the index of the first occurrence of the character in the character sequence represented by this object that is greater than or equal to `fromIndex`, or `-1` if the character does not occur.

    - #### substring

          public XMLString substring(int beginIndex)

      Returns a new string that is a substring of this string. The substring begins with the character at the specified index and extends to the end of this string.

      Examples:

      >      "unhappy".substring(2) returns "happy"
      >      "Harbison".substring(3) returns "bison"
      >      "emptiness".substring(9) returns "" (an empty string)

      Specified by:
        `substring` in interface `XMLString`
      Overrides:
        `substring` in class `XString`
      Parameters:
        `beginIndex` - the beginning index, inclusive.
      Returns:
        the specified substring.
      Throws:
        `java.lang.IndexOutOfBoundsException` - if `beginIndex` is negative or larger than the length of this `String` object.

    - #### substring

          public XMLString substring(int beginIndex,
                                     int endIndex)

      Returns a new string that is a substring of this string. The substring begins at the specified `beginIndex` and extends to the character at index `endIndex - 1`. Thus the length of the substring is `endIndex-beginIndex`.
      Specified by:
        `substring` in interface `XMLString`
      Overrides:
        `substring` in class `XString`
      Parameters:
        `beginIndex` - the beginning index, inclusive.
        `endIndex` - the ending index, exclusive.
      Returns:
        the specified substring.
      Throws:
        `java.lang.IndexOutOfBoundsException` - if the `beginIndex` is negative, or `endIndex` is larger than the length of this `String` object, or `beginIndex` is larger than `endIndex`.

    - #### concat

          public XMLString concat(java.lang.String str)

      Concatenates the specified string to the end of this string.
      Specified by:
        `concat` in interface `XMLString`
      Overrides:
        `concat` in class `XString`
      Parameters:
        `str` - the `String` that is concatenated to the end of this `String`.
      Returns:
        a string that represents the concatenation of this object's characters followed by the string argument's characters.
      Throws:
        `java.lang.NullPointerException` - if `str` is `null`.

    - #### trim

          public XMLString trim()

      Removes white space from both ends of this string.
      Specified by:
        `trim` in interface `XMLString`
      Overrides:
        `trim` in class `XString`
      Returns:
        this string, with white space removed from the front and end.

    - #### fixWhiteSpace

          public XMLString fixWhiteSpace(boolean trimHead,
                                         boolean trimTail,
                                         boolean doublePunctuationSpaces)

      Conditionally trim all leading and trailing whitespace in the specified String. All strings of white space are replaced by a single space character (#x20), except spaces after punctuation which receive double spaces if doublePunctuationSpaces is true. This function may be useful to a formatter, but to get first class results, the formatter should probably do it's own white space handling based on the semantics of the formatting object.
      Specified by:
        `fixWhiteSpace` in interface `XMLString`
      Overrides:
        `fixWhiteSpace` in class `XString`
      Parameters:
        `trimHead` - Trim leading whitespace?
        `trimTail` - Trim trailing whitespace?
        `doublePunctuationSpaces` - Use double spaces for punctuation?
      Returns:
        The trimmed string.

    - #### toDouble

          public double toDouble()

      Convert a string to a double -- Allowed input is in fixed notation ddd.fff. %OPT% CHECK PERFORMANCE against generating a Java String and converting it to double. The advantage of running in native machine code -- perhaps even microcode, on some systems -- may more than make up for the cost of allocating and discarding the additional object. We need to benchmark this. %OPT% More importantly, we need to decide whether we _care_ about the performance of this operation. Does XString.toDouble constitute any measurable percentage of our typical runtime? I suspect not!
      Specified by:
        `toDouble` in interface `XMLString`
      Overrides:
        `toDouble` in class `XString`
      Returns:
        A double value representation of the string, or return Double.NaN if the string can not be converted.

Copyright © 2023 Apache XML Project. All Rights Reserved.